/**
 * Created by IntelliJ IDEA.
 * User: turtle
 * Date: Sep 28, 2003
 * Time: 4:44:56 PM
 * To change this template use Options | File Templates.
 */
package ru.nchelny.bazon.MemoryGame.main;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.io.*;
import java.security.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Properties;

import ru.nchelny.bazon.MemoryGame.utils.TRHashMap;
import ru.nchelny.bazon.MemoryGame.utils.Constants;

public class ConfigurationReaderWriter
{
    private String configFileName = new String("MemoryGame_Data.xml");
    private DocumentBuilderFactory configDBF;
    private DocumentBuilder configDBuilder;
    private Document configDoc;

    private int errorCode = 0;
    public static int SUCCESS = 0;
    private static int ERROR_ON_LOAD = 1;
    private static int ERROR_ON_PARSE = 2;

	private ArrayList easy = new ArrayList();
	private ArrayList normal = new ArrayList();
	private ArrayList hard = new ArrayList();

    public HashMap configEntity = new HashMap();

	private KeyPair pair = null;

    ConfigurationReaderWriter()
    {
        configDBF = DocumentBuilderFactory.newInstance();
        configDBF.setValidating(true);
        configDBF.setIgnoringElementContentWhitespace(true);

        try
        {
            configDBuilder = configDBF.newDocumentBuilder();
            configDBuilder.setErrorHandler(configErrorHandler);
            configDoc = configDBuilder.parse(new File(configFileName));

	        genKeys();

	        easy = getTableValues("easy");
	        normal = getTableValues("normal");
	        hard = getTableValues("hard");
        }
        catch (ParserConfigurationException e)
        {
        }
        catch (SAXException e)
        {
	        System.out.println("Problems occured during parisng");
            setErrorCode(ERROR_ON_PARSE);
        }
        catch (IOException e)
        {
            System.out.println("Configuration file not found");
            setErrorCode(ERROR_ON_LOAD);
        }
    }

    private ErrorHandler configErrorHandler = new ErrorHandler()
    {
        public void fatalError(SAXParseException e)
        {
            System.out.println(e.getSystemId());
            System.out.println("[line " + e.getLineNumber() + "] " +
                    e.getLocalizedMessage());
            setErrorCode(ERROR_ON_PARSE);
        }

        public void error(SAXParseException e)
        {
            System.out.println(e.getSystemId());
            System.out.println("[line " + e.getLineNumber() + "] " +
                    e.getLocalizedMessage());
            setErrorCode(ERROR_ON_PARSE);
        }

        public void warning(SAXParseException e)
        {
            System.out.println(e.getSystemId());
            System.out.println("[line " + e.getLineNumber() + "] " +
                    e.getLocalizedMessage());
        }
    };

    private ErrorListener errorListener = new ErrorListener()
    {
        public void fatalError(TransformerException e)
        {
            e.printStackTrace();
        }

        public void error(TransformerException e)
        {
            e.printStackTrace();
        }

        public void warning(TransformerException e)
        {
            e.printStackTrace();
        }
    };

    public void readConfig()
    {
        Element rootConfig = configDoc.getDocumentElement();
        Element configNode =
                (Element)rootConfig.getElementsByTagName("config").item(0);
        configEntity.put("locale", configNode.getAttribute("locale"));
        configEntity.put("theme", configNode.getAttribute("theme"));
        configEntity.put("level", configNode.getAttribute("level"));
        configEntity.put("fullscreen", configNode.getAttribute("fullscreen"));
	    configEntity.put("lastPlayer", configNode.getAttribute("lastPlayer"));
	    configEntity.put("colorifix", configNode.getAttribute("colorifix"));
    }

    public void writeConfig()
    {
        TransformerFactory configTransformer = TransformerFactory.newInstance();
        Transformer serializer = null;

        try
        {
            // Do writing
            configTransformer.setErrorListener(errorListener);
            serializer = configTransformer.newTransformer();

            Properties oprop = new Properties();

            oprop.put("method", "xml");
            oprop.put("indent", "yes");
            oprop.put("doctype-system", "MemoryGame_Data.dtd");
            serializer.setOutputProperties(oprop);
            serializer.transform(new DOMSource(configDoc),
                    new StreamResult(new File(configFileName)));
        }
        catch (TransformerConfigurationException e)
        {
            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        }
        catch (TransformerException e)
        {
            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        }
    }

    public void setTheme(String theme)
    {
        configEntity.remove("theme");
        configEntity.put("theme", theme);
        Element rootConfig = configDoc.getDocumentElement();
        Element configNode =
                (Element)rootConfig.getElementsByTagName("config").item(0);
        configNode.setAttribute("theme", theme);
    }

	public HashMap findEqual(String name)
	{
		HashMap retval = null;

		ArrayList current = null;

		String level = getLevel();

		if(level.equalsIgnoreCase("easy"))
		{
			current = easy;
		}
		else if(level.equalsIgnoreCase("normal"))
		{
			current = normal;
		}
		else if(level.equalsIgnoreCase("hard"))
		{
			current = hard;
		}

		Iterator it = current.iterator();
		while(it.hasNext())
		{
			HashMap entry = (HashMap)it.next();

			String namee = (String)entry.get("name");

			if(name.equals(namee))
			{
				retval = entry;
			}
		}

		return retval;
	}

	public void setColorifix(String colorifix)
	{
        configEntity.remove("colorifix");
		configEntity.put("colorifix", colorifix);
		Element rootConfig = configDoc.getDocumentElement();
		Element configNode =
		        (Element)rootConfig.getElementsByTagName("config").item(0);
		configNode.setAttribute("colorifix", colorifix);
	}

	public void setLastPlayer(String lastPlayer)
	{
		configEntity.remove("lastPlayer");
		configEntity.put("lastPlayer", lastPlayer);
		Element rootConfig = configDoc.getDocumentElement();
		Element configNode =
		        (Element)rootConfig.getElementsByTagName("config").item(0);
		configNode.setAttribute("lastPlayer", lastPlayer);
	}

    public void setLevel(String level)
    {
        configEntity.remove("level");
        configEntity.put("level", level);
        Element rootConfig = configDoc.getDocumentElement();
        Element configNode =
                (Element)rootConfig.getElementsByTagName("config").item(0);
        configNode.setAttribute("level", level);
    }

	public void setProperty(String property)
	{
		configEntity.remove("locale");
		configEntity.put("locale", property);
		Element rootConfig = configDoc.getDocumentElement();
		Element configNode =
		        (Element)rootConfig.getElementsByTagName("config").item(0);
		configNode.setAttribute("locale", property);
	}

	public boolean getColorifix()
	{
		boolean retval = true;

		String colorifix = (String)configEntity.get("colorifix");
		retval = colorifix.equalsIgnoreCase("no") ? false : true;

		return retval;
	}

	public String getLevel()
	{
		String retval = (String)configEntity.get("level");
		return retval;
	}

	public ArrayList getCurrentTableValues()
	{
		ArrayList retval = new ArrayList();

		String level = getLevel();

		if(level.equalsIgnoreCase("easy"))
		{
			retval = easy;
		}
		else if(level.equalsIgnoreCase("normal"))
		{
			retval = normal;
		}
		else if(level.equalsIgnoreCase("hard"))
		{
			retval = hard;
		}

		return retval;
	}

	public void insertNewEntry(String name, String hi_score, String last_score, String games)
	{
		ArrayList refal = null;
		String level = getLevel();

		Element rootConfig = configDoc.getDocumentElement();
		Element configNode = null;

		if(level.equalsIgnoreCase("easy"))
		{
			configNode =
		        (Element)rootConfig.getElementsByTagName("scores_list_easy").item(0);
			refal = easy;
		}
		else if(level.equalsIgnoreCase("normal"))
		{
			configNode =
		        (Element)rootConfig.getElementsByTagName("scores_list_normal").item(0);
			refal = normal;
		}
		else if(level.equalsIgnoreCase("hard"))
		{
			configNode =
		        (Element)rootConfig.getElementsByTagName("scores_list_hard").item(0);
			refal = hard;
		}

		String hash = genHash(name + hi_score + last_score + games);

		if(hash != null)
		{
			HashMap playerHM = new HashMap();
			playerHM.put("name", name);
			playerHM.put("hi_score", hi_score);
			playerHM.put("last_score", last_score);
			playerHM.put("games", games);

			Element newChild = configDoc.createElement("entry");
			newChild.setAttribute("name", name);
			newChild.setAttribute("hi_score", hi_score);
			newChild.setAttribute("last_score", last_score);
			newChild.setAttribute("games", games);

			newChild.setAttribute("hash", hash);
			configNode.appendChild(newChild);

			playerHM.put("xml_entry", newChild);
			refal.add(playerHM);
		}
	}

	public String genHash(String sum)
	{
		String retval = null;

		try
		{
			PrivateKey priv = getPrivateKey();

			Signature dsa = Signature.getInstance("SHA1withDSA", "SUN");
			dsa.initSign(priv);

			ByteArrayInputStream bais = new ByteArrayInputStream(sum.getBytes());
			BufferedInputStream bis = new BufferedInputStream(bais);
			byte[] buffer = new byte[1024];
	        int len;
			while(bais.available() != 0)
			{
	            len = bis.read(buffer);
				dsa.update(buffer, 0, len);
			}
			byte[] realSign = dsa.sign();

	        retval = toStringBA(realSign);
		}
		catch(NoSuchAlgorithmException e)
		{
		}
		catch(NoSuchProviderException e)
		{
		}
		catch(InvalidKeyException e)
		{
		}
		catch(IOException e)
		{
		}
		catch(SignatureException e)
		{
		}

		return retval;
	}

	private String toStringBA(byte[] value)
	{
		String retval = new String("");

		for(int i = 0; i < value.length; i++)
		{
			byte current = value[i];
			int currentIntValue = (current < 0 ? current + 256 : current);

			String byteString = Integer.toHexString(currentIntValue);
			byteString = (byteString.length() == 1 ?
			        "0" + byteString : byteString);
			retval += byteString;
		}
		retval = retval.toUpperCase();

		return retval;
	}

	private byte[] fromStringBA(String value)
	{
		byte[] retval = new byte[value.length() / 2];

		HashMap hex = new TRHashMap(Constants.hexStringToDecInteger);

		for(int i = 0; i < value.length() / 2; i++)
		{
			char[] curByteCI = new char[2];

			value.getChars(i * 2,
			               i * 2 + 2,
			               curByteCI,
			               0);

			int curData = ((Integer)hex.get("" + curByteCI[0])).intValue() * 16 +
			              ((Integer)hex.get("" + curByteCI[1])).intValue();
			byte curByte = (byte)curData;
			retval[i] = curByte;
		}

		return retval;
	}

	private void genKeys()
	{
		try
		{
			ByteArrayInputStream bais = new ByteArrayInputStream(Constants.KeyPairBA);
			ObjectInputStream ois = new ObjectInputStream(bais);
			pair = (KeyPair)ois.readObject();
			ois.close();
			bais.close();
		}
		catch(IOException e)
		{
		}
		catch(ClassNotFoundException e)
		{
		}
	}

	private PrivateKey getPrivateKey()
	{
		PrivateKey priv = pair.getPrivate();

		return priv;
	}

	private PublicKey getPublicKey()
	{
		PublicKey pub = pair.getPublic();

		return pub;
	}

	private boolean deHash(String sum, String hash)
	{
		boolean retval = false;

		try
		{
			PublicKey pub = getPublicKey();

			byte[] sigToVerify = fromStringBA(hash);

			Signature sig = Signature.getInstance("SHA1withDSA", "SUN");
			sig.initVerify(pub);

			ByteArrayInputStream bais = new ByteArrayInputStream(sum.getBytes());
			BufferedInputStream bis = new BufferedInputStream(bais);
			byte[] buffer = new byte[1024];
	        int len;
			while(bais.available() != 0)
			{
	            len = bis.read(buffer);
				sig.update(buffer, 0, len);
			}

            retval = sig.verify(sigToVerify);
		}
		catch(NoSuchAlgorithmException e)
		{
		}
		catch(NoSuchProviderException e)
		{
		}
		catch(InvalidKeyException e)
		{
		}
		catch(IOException e)
		{
		}
		catch(SignatureException e)
		{
		}
		catch(Exception e)
		{
		}

		return retval;
	}

	private ArrayList getTableValues(String level)
	{
		ArrayList retval = new ArrayList();

		Element rootConfig = configDoc.getDocumentElement();
		Element configNode = null;

		if(level.equalsIgnoreCase("easy"))
		{
			configNode =
		        (Element)rootConfig.getElementsByTagName("scores_list_easy").item(0);
		}
		else if(level.equalsIgnoreCase("normal"))
		{
			configNode =
		        (Element)rootConfig.getElementsByTagName("scores_list_normal").item(0);
		}
		else if(level.equalsIgnoreCase("hard"))
		{
			configNode =
		        (Element)rootConfig.getElementsByTagName("scores_list_hard").item(0);
		}

		ArrayList removedNodes = new ArrayList();
		NodeList scores = configNode.getElementsByTagName("entry");

		for(int i = 0; i < scores.getLength(); i++)
		{
			HashMap currentEHM = new HashMap();
			Element currentEntry = (Element)scores.item(i);

            String name = currentEntry.getAttribute("name").toString();
			String hi_score = currentEntry.getAttribute("hi_score").toString();
			String last_score = currentEntry.getAttribute("last_score").toString();
			String games = currentEntry.getAttribute("games").toString();
			String hash = currentEntry.getAttribute("hash").toString();

			boolean compHash = deHash(name + hi_score + last_score + games, hash);

			if(compHash)
			{
				currentEHM.put("name", name);
				currentEHM.put("hi_score", hi_score);
				currentEHM.put("last_score", last_score);
				currentEHM.put("games", games);
				currentEHM.put("xml_entry", currentEntry);
				retval.add(currentEHM);
			}
			else
			{
				removedNodes.add(currentEntry);
			}
		}

		for(int i = 0; i < removedNodes.size(); i++)
		{
			Element currentEntry = (Element)removedNodes.get(i);
			configNode.removeChild(currentEntry);
		}

		return retval;
	}

    public int getErrorCode()
    {
        return errorCode;
    }

    private void setErrorCode(int errorCode)
    {
        this.errorCode = errorCode;
    }
}
