/**
 * Created by IntelliJ IDEA.
 * User: turtle
 * Date: Jun 14, 2003
 * Time: 3:19:02 PM
 * To change this template use Options | File Templates.
 */
package ru.nchelny.bazon.MemoryGame.main;

import org.w3c.dom.Element;

import javax.swing.*;
import javax.swing.Timer;
import java.awt.*;
import java.awt.font.TextAttribute;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.nio.channels.FileLock;
import java.net.URL;

import ru.nchelny.bazon.MemoryGame.utils.*;
import ru.nchelny.bazon.MemoryGame.swingutils.*;
import ru.nchelny.bazon.MemoryGame.notBAZON.ClipPlayer;

public class MemoryMain extends JFrame
{
	private static ConfigurationReaderWriter configReader =
	        new ConfigurationReaderWriter();

	private MemoryMain frameMain = null;

	private int Bwidth = 5;
	private final int BwidthEasy = 4;
	private final int BwidthNormal = 6;
	private final int BwidthHard = 8;
	private int Bheight = 6;
	private final int BheightEasy = 5;
	private final int BheightNormal = 7;
	private final int BheightHard = 9;

	private final JMenu fileMenu = new JMenu("File");
	private final JMenuItem meniNew = new JMenuItem("New game");
	private final JMenu levelMenu = new JMenu("Game Level");
	private final JCheckBoxMenuItem meniEasy = new JCheckBoxMenuItem("Easy");
	private final JCheckBoxMenuItem meniNormal = new JCheckBoxMenuItem("Difficult");
	private final JCheckBoxMenuItem meniHard = new JCheckBoxMenuItem("Hard");
	private final JMenuItem recordsMenu = new JMenuItem("Records table");
	private final JMenu langMenu = new JMenu("Language");
	private final JMenu themesMenu = new JMenu("Themes");
	private final JMenuItem meniExit = new JMenuItem("Exit game");
	private final JMenu helpMenu = new JMenu("Help");
	private final JMenuItem meniRules = new JMenuItem("Game RULES");
	private final JMenuItem meniAbout = new JMenuItem("About program");
	private boolean canDoAction = true;
	private boolean timerWorking = false;
	private final JLabel JLabelNextTime = new JLabel("Theme changes will be applied in New game");
	private TRJButton b1 = new TRJButton();
	private TRJButton b2 = new TRJButton();
	private JButton lblScores = new JButton("0");
	private JTextField txtPlayerName = new JTextField();
	/**/
	private final ArrayList listLocales = new ArrayList();
	private final ArrayList imageList = new ArrayList();
	private ArrayList listThemes = new ArrayList();

	private String properties = "props";
	private String themes = "Themes";
	private String Theme = "Turtle";
	private boolean OkToLoad = true;
	private boolean NewGameStart = true;
	private String dialogNextTimeS = new String("System Information");

	ClassPathParser cpp = new ClassPathParser(themes, properties);

	private ClipPlayer soundOpen;
	private ClipPlayer soundTwins;
	private ClipPlayer soundNew;
	private ClipPlayer soundEnd;

	private int Opened = 0;
	private int Scores = 0;
	private final int MaxC = 100;
	private final int MinC = 20;

	private String txtsName = new String("Name");
	private String lastPlayer = new String("");
	private String congratulations = new String("Congratulations!");
	private String beatRecord = new String("You have beat Record on this game level");

	private JLabel txtsNameLabel = new JLabel(txtsName);

	private Random RandomSeed = new Random();

	private void setIntMessages(ResourceBundle messagesF, String loc)
	{
		try
		{
			setTitle(messagesF.getString("maintitle"));
		}
		catch(MissingResourceException e) {}
		try
		{
			fileMenu.setText(messagesF.getString("smenuFile"));
		}
		catch(MissingResourceException e) {}
		try
		{
			meniNew.setText(messagesF.getString("smeniNew"));
		}
		catch(MissingResourceException e) {}
		try
		{
			levelMenu.setText(messagesF.getString("smenuLevel"));
		}
		catch(MissingResourceException e) {}
		try
		{
			recordsMenu.setText(messagesF.getString("recTable"));
		}
		catch(MissingResourceException e) {}
		try
		{
			meniEasy.setText(messagesF.getString("smeniEasy"));
		}
		catch(MissingResourceException e) {}
		try
		{
			meniNormal.setText(messagesF.getString("smeniNormal"));
		}
		catch(MissingResourceException e) {}
		try
		{
			meniHard.setText(messagesF.getString("smeniHard"));
		}
		catch(MissingResourceException e) {}
		try
		{
			langMenu.setText(messagesF.getString("smenuLang"));
		}
		catch(MissingResourceException e) {}
		try
		{
			themesMenu.setText(messagesF.getString("smenuThemes"));
		}
		catch(MissingResourceException e) {}
		try
		{
			meniExit.setText(messagesF.getString("smeniExit"));
		}
		catch(MissingResourceException e) {}
		try
		{
			helpMenu.setText(messagesF.getString("smenuHelp"));
		}
		catch(MissingResourceException e) {}
		try
		{
			meniRules.setText(messagesF.getString("smeniRules"));
		}
		catch(MissingResourceException e) {}
		try
		{
			meniAbout.setText(messagesF.getString("smeniAbout"));
		}
		catch(MissingResourceException e) {}
		try
		{
			JLabelNextTime.setText(messagesF.getString("nextTime"));
		}
		catch(MissingResourceException e) {}
		try
		{
			dialogNextTimeS = messagesF.getString("sysInf");
		}
		catch(MissingResourceException e) {}

		try
		{
			txtsName = messagesF.getString("txtsName");
			txtsNameLabel.setText(txtsName);
		}
		catch(MissingResourceException e) {}
		try
		{
			congratulations = messagesF.getString("congratulations");
		}
		catch(MissingResourceException e) {}
		try
		{
			beatRecord = messagesF.getString("beatRecord");
		}
		catch(MissingResourceException e) {}

		try
		{
			RecTable.tabREC = messagesF.getString("tabREC");
		}
		catch(MissingResourceException e) {}
		try
		{
			RecTable.playerName = messagesF.getString("playerName");
		}
		catch(MissingResourceException e) {}
		try
		{
			RecTable.playerHiScore = messagesF.getString("playerHiScore");
		}
		catch(MissingResourceException e) {}
		try
		{
			RecTable.playerLastScore = messagesF.getString("playerLastScore");
		}
		catch(MissingResourceException e) {}
		try
		{
			RecTable.playerGames = messagesF.getString("playedGames");
		}
		catch(MissingResourceException e) {}
		try
		{
			RecTable.dynamicColors = messagesF.getString("dynamicColors");
		}
		catch(MissingResourceException e) {}

		try
		{
			JMGRules.mgSimpleRules = messagesF.getString("mgSimpleRules");
		}
		catch(MissingResourceException e) {};
		try
		{
			JMGRules.inDocSee = messagesF.getString("inDocSee");
		}
		catch(MissingResourceException e) {};

		configReader.setProperty(loc);

		for(int fnu = 0; fnu < listLocales.size(); fnu++)
		{
			((JCheckBoxMenuItem)listLocales.get(fnu)).setState(false);
			try
			{
//				if(loc.equalsIgnoreCase("Default BAZON"))
//				{
//					((JCheckBoxMenuItem)listLocales.get(fnu)).setState(true);
//				}
				if(((JCheckBoxMenuItem)listLocales.get(fnu)).getText().indexOf(loc) != -1)
				{
					((JCheckBoxMenuItem)listLocales.get(fnu)).setState(true);
				}
			}
			catch(MissingResourceException e)
			{
			}
		}
	}

	private void readImageIcons()
	{
		int iz;

		imageList.removeAll(imageList);
		for(iz = 0; iz < BwidthHard * BheightHard / 2; iz++)
		{
			String imageName =
			        new String("/" + themes + "/" + Theme +
	  	                       "/pic/" +
			                   (iz / 10 < 1 ?
			                   "0" + Integer.toString(iz) :
			                   Integer.toString(iz)) +
			                   ".png");
			URL imageURL = this.getClass().getResource(imageName);

			ImageIcon butIcon = new ImageIcon(imageURL);

			imageList.add(butIcon);
		}
		URL picURL = this.getClass().getResource("/" + themes + "/" + Theme + "/pic/pic.png");
		imageList.add(new ImageIcon(picURL));
		OkToLoad = false;
	}

	private void setSound()
	{
		soundOpen = new ClipPlayer(
		        this.getClass().getResource("/" + themes + "/" + Theme + "/mus/open.wav"));
		soundTwins = new ClipPlayer(
		        this.getClass().getResource("/" + themes + "/" + Theme + "/mus/twins.wav"));
		soundNew = new ClipPlayer(
		        this.getClass().getResource("/" + themes + "/" + Theme + "/mus/new.wav"));
		soundEnd = new ClipPlayer(
		        this.getClass().getResource("/" + themes + "/" + Theme + "/mus/end.wav"));
	}

	public MemoryMain()
	{
		frameMain = this;

//		String language;
//		String country;
		super.setTitle("MemoryGame from BAZON Group (locale error)");

		addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				processExit();
			}
		});

		addWindowStateListener(new WindowStateListener()
		{
			public void windowStateChanged(WindowEvent e)
			{
				if((e.getOldState() == MAXIMIZED_HORIZ || e.getOldState() == MAXIMIZED_VERT
				        || e.getOldState() == MAXIMIZED_BOTH) && e.getNewState() == NORMAL)
					e.getWindow().pack();
				Dimension frameD = new Dimension(e.getWindow().getSize());
				Dimension screenD = new Dimension(Toolkit.getDefaultToolkit().getScreenSize());
				e.getWindow().setLocation((int)(screenD.getWidth() - frameD.getWidth()) / 2,
				                          (int)(screenD.getHeight() - frameD.getHeight()) * 2 / 5);
			}
		});
		// Creating menu
		JMenuBar mainMenu = new JMenuBar();
		setJMenuBar(mainMenu);

		fileMenu.setMnemonic(KeyEvent.VK_F);

		meniNew.setMnemonic(KeyEvent.VK_N);
		meniNew.addActionListener(newGame);

		// Hard submenu
		levelMenu.setMnemonic(KeyEvent.VK_G);

		meniEasy.setMnemonic(KeyEvent.VK_E);
		meniNormal.setMnemonic(KeyEvent.VK_D);
		meniHard.setMnemonic(KeyEvent.VK_H);

		lastPlayer = (String)configReader.configEntity.get("lastPlayer");

		String level = (String)configReader.configEntity.get("level");
		meniEasy.setState(false);
		meniNormal.setState(false);
		meniHard.setState(false);
		if(level.equalsIgnoreCase("easy"))
		{
			meniEasy.setState(true);
			Bwidth = BwidthEasy;
			Bheight = BheightEasy;
		}
		else if(level.equalsIgnoreCase("normal"))
		{
			meniNormal.setState(true);
			Bwidth = BwidthNormal;
			Bheight = BheightNormal;
		}
		else if(level.equalsIgnoreCase("hard"))
		{
			meniHard.setState(true);
			Bwidth = BwidthHard;
			Bheight = BheightHard;
		}

		meniEasy.addActionListener(easyPressed);
		meniNormal.addActionListener(normalPressed);
		meniHard.addActionListener(hardPressed);

		levelMenu.add(meniEasy);
		levelMenu.add(meniNormal);
		levelMenu.add(meniHard);

		recordsMenu.setMnemonic(KeyEvent.VK_R);
		recordsMenu.addActionListener(recTable);

		// Lang menus
		langMenu.setMnemonic(KeyEvent.VK_A);

		meniExit.setMnemonic(KeyEvent.VK_X);
		meniExit.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				processExit();
			}
		});

		// Setting help menu
		helpMenu.setMnemonic(KeyEvent.VK_H);

		meniRules.setMnemonic(KeyEvent.VK_R);
		meniRules.addActionListener(show_rules);

		meniAbout.setMnemonic(KeyEvent.VK_A);
		meniAbout.addActionListener(show_about);

		/**/
		ArrayList localesMNU = new ArrayList();
		int ifnum, colCounter = 0;

		ArrayList propList = cpp.getPropListOfEndsWith(".properties");

        for(ifnum = 0; ifnum < propList.size(); ifnum++)
        {
	        String fname = (String)propList.get(ifnum);
	        final JCheckBoxMenuItem exMenuI = new JCheckBoxMenuItem("");

	        exMenuI.setState(false);

	        if(fname.indexOf("_") == -1)
	        {
		        fname = "Default BAZON";
//		        language = "";
//		        country = "";
	        }
	        else
	        {
		        fname = fname.substring(fname.indexOf("_") + 1, fname.indexOf(".properties"));
//		        language = fname.substring(0, 2);
//		        country = fname.substring(fname.indexOf("_") + 1, fname.indexOf("_") + 3);
//		        if(fname.indexOf((getLocale().getLanguage() + "_"
//		                          + getLocale().getCountry())) == 0)
//		        {
//			        fname += " (current locale)";
//		        }
	        }
	        localesMNU.add(fname + ":" + Integer.toString(colCounter));
	        colCounter++;

//	        final String languageF = language;
//	        final String countryF = country;
	        final String fname_copy = fname;

	        exMenuI.setText(fname);
	        exMenuI.addActionListener(new ActionListener()
	        {
		        public void actionPerformed(ActionEvent e)
		        {
			        try
			        {
				        ResourceBundle messagesF = null;

				        if(fname_copy.equalsIgnoreCase("Default BAZON"))
				        {
					        messagesF = ResourceBundle.getBundle(properties + "/" +
   	                                    "MessagesBundle", new Locale("", ""));
				        }
				        else
				        {
					        messagesF = ResourceBundle.getBundle(properties + "/" +
   	                                    "MessagesBundle_" + fname_copy);
				        }
				        setIntMessages(messagesF, fname_copy);
			        }
			        catch(Exception ee)
			        {

			        }
		        }
	        });
	        listLocales.add(exMenuI);
		}
		Collections.sort(localesMNU);
		for(ifnum = 0; ifnum < localesMNU.size(); ifnum++)
		{
			StringTokenizer tk = new StringTokenizer(localesMNU.get(ifnum).toString(), ":");
			tk.nextToken();
			langMenu.add((JCheckBoxMenuItem)listLocales.get(Integer.parseInt(tk.nextToken())));
		}

		// Set theme     
		Theme = (String)configReader.configEntity.get("theme");
		ArrayList themesList = cpp.getThemeList();

		for(ifnum = 0; ifnum < themesList.size(); ifnum++)
		{
			String curviewTheme = (String)themesList.get(ifnum);

			if(checkDir(themes + "/" + curviewTheme))
			{
				final JCheckBoxMenuItem exMenuT = new JCheckBoxMenuItem(curviewTheme);

				exMenuT.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						Theme = exMenuT.getText();
						configReader.setTheme(Theme);
						OkToLoad = true;

						SetButtonGal();

						final JDialog dialogNextTime = new JDialog(frameMain, dialogNextTimeS, true);

						JButton bOK = new JButton("OK");

						bOK.addActionListener(new ActionListener()
						{
							public void actionPerformed(ActionEvent e)
							{
								dialogNextTime.dispose();
							}
						});

						JPanel dcontentPane = new JPanel();
						dcontentPane.setBorder(BorderFactory.createEtchedBorder());
						dcontentPane.setLayout(new GridBagLayout());
						dcontentPane.add(JLabelNextTime, new GridBagConstraints(1, 1, 1, 1, 1.0, 1.0,
						                                                        GridBagConstraints.CENTER, GridBagConstraints.NONE,
						                                                        new Insets(5, 5, 5, 5), 0, 0));
						dcontentPane.add(bOK, new GridBagConstraints(1, 2, 1, 1, 1.0, 1.0,
						                                             GridBagConstraints.CENTER, GridBagConstraints.NONE,
						                                             new Insets(5, 0, 5, 0), 0, 0));
						dialogNextTime.setContentPane(dcontentPane);
						dialogNextTime.pack();

						Dimension frameD = new Dimension(dialogNextTime.getSize());
						Dimension screenD = new Dimension(Toolkit.getDefaultToolkit().getScreenSize());
						dialogNextTime.setLocation((int)(screenD.getWidth() - frameD.getWidth()) / 2,
						                           (int)(screenD.getHeight() - frameD.getHeight()) * 2 / 5);

						dialogNextTime.setVisible(true);
					}
				});
				listThemes.add(exMenuT);
			}
		}

		SetButtonGal();

		Collections.sort(listThemes, new Comparator()
		{
			public int compare(Object o1, Object o2)
			{
				return o1.toString().compareTo(o2.toString());
			}
		});

		for(ifnum = 0; ifnum < listThemes.size(); ifnum++)
		{
			themesMenu.add((JCheckBoxMenuItem)listThemes.get(ifnum));
		}

		// Setting File menu
		fileMenu.add(meniNew);
		fileMenu.add(levelMenu);
		fileMenu.add(recordsMenu);
		fileMenu.addSeparator();
		fileMenu.add(langMenu);
		fileMenu.addSeparator();
		fileMenu.add(themesMenu);
		fileMenu.addSeparator();
		fileMenu.add(meniExit);

		helpMenu.add(meniRules);
		helpMenu.add(meniAbout);

		// Setting main menu
		mainMenu.add(fileMenu);
		mainMenu.add(helpMenu);

		readImageIcons();
		setSound();
		addNComponents();
	}

	private boolean checkDir(String nampath)
	{
		boolean retval = true;

		for(int il = 0; il < BwidthHard * BheightHard / 2; il++)
		{
			String chkpath = new String(nampath + "/pic/" +
			                            (il / 10 < 1 ?
			                             "0" + Integer.toString(il) :
			                             Integer.toString(il)) +
			                             ".png");

			if(!cpp.exist(chkpath))
			{
				retval = false;
			}
		}
		if(!cpp.exist(nampath + "/pic/" + "pic.png"))
		{
			retval = false;
		}

		return retval;
	}

	private void SetButtonGal()
	{
		int i;

		for(i = 0; i < listThemes.size(); i++)
		{
			if(((JCheckBoxMenuItem)listThemes.get(i)).getText().equals(Theme))
			{
				((JCheckBoxMenuItem)listThemes.get(i)).setState(true);
			}
			else
			{
				((JCheckBoxMenuItem)listThemes.get(i)).setState(false);
			}
		}
	}

	private ActionListener easyPressed = new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			if(meniEasy.getState())
			{
				meniEasy.setState(true);
				meniNormal.setState(false);
				meniHard.setState(false);
				Bwidth = BwidthEasy;
				Bheight = BheightEasy;
				configReader.setLevel("easy");
				addNComponents();
			}
			else
			{
				meniEasy.setState(true);
			}
		}
	};

	private ActionListener normalPressed = new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			if(meniNormal.getState())
			{
				meniEasy.setState(false);
				meniNormal.setState(true);
				meniHard.setState(false);
				Bwidth = BwidthNormal;
				Bheight = BheightNormal;
				configReader.setLevel("normal");
				addNComponents();
			}
			else
			{
				meniNormal.setState(true);
			}
		}
	};

	private ActionListener hardPressed = new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			if(meniHard.getState())
			{
				meniEasy.setState(false);
				meniNormal.setState(false);
				meniHard.setState(true);
				Bwidth = BwidthHard;
				Bheight = BheightHard;
				configReader.setLevel("hard");
				addNComponents();
			}
			else
			{
				meniHard.setState(true);
			}
		}
	};

	private ActionListener newGame = new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			NewGameStart = true;
			addNComponents();
		}
	};

	private ActionListener waitAndClose = new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			timerClose();
		}
	};

	private void timerClose()
	{
		b1.setIcon((ImageIcon)imageList.get(36));
		b2.setIcon((ImageIcon)imageList.get(36));
		timeToClose.stop();
		canDoAction = true;
		timerWorking = false;
	}

	private void addNComponents()
	{
		if(OkToLoad) // first Reading image components
		{
			readImageIcons();
			setSound();
		}

		soundNew.play(0);

		Opened = 0;
		lblScores.setForeground(null);
		lblScores.setBackground(null);
		Scores = 0;

		// Creating buttons
		final ArrayList pushButton = new ArrayList();
		final ArrayList intTable = new ArrayList();
		final ArrayList intTabALL = new ArrayList();
		final ArrayList intTabBwBh = new ArrayList();
		final TRBoolean OneYetOpened = new TRBoolean();
		int i, j;

		for(i = 0; i < BwidthHard * BheightHard / 2; i++)
		{
			intTabALL.add(new Integer(i));
		}

		RandomSeed.setSeed(Calendar.getInstance().getTimeInMillis());
		for(i = 0; i < Bwidth * Bheight; i += 2)
		{
			int rsv = RandomSeed.nextInt(intTabALL.size());

			intTabBwBh.add(intTabALL.get(rsv));
			intTabBwBh.add(intTabALL.get(rsv));
			intTabALL.remove(rsv);
		}

		for(i = 0; i < Bwidth * Bheight; i++)
		{
			int rsv = RandomSeed.nextInt(intTabBwBh.size());

			intTable.add(intTabBwBh.get(rsv));
			intTabBwBh.remove(rsv);
		}

		for(i = 0; i < Bwidth * Bheight; i++)
		{
			final TRJButton exButton = new TRJButton();

//            exButton.setIcon(new ImageIcon("pic/pic.gif"));
			exButton.setIcon((ImageIcon)imageList.get(36));
			exButton.setPreferredSize(new Dimension(36, 36));

			exButton.setBorder(BorderFactory.createEmptyBorder());
//            final int x = i / Bwidth;
//            final int y = j % Bwidth;
			final int ij = i;
			final int setInt = ((Integer)intTable.get(ij)).intValue();

			// Events for buttons Action
			exButton.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					txtPlayerName.setEditable(false);
//					lastPlayer = txtPlayerName.getText();
					if(!lastPlayer.equals(""))
					{
						configReader.setLastPlayer(lastPlayer);
					}

					if(timerWorking)
					{
						timerClose();
					}
					if(canDoAction)
					{
						if(exButton.getCanPressState() &&
						        (OneYetOpened.getLast() != ij))
						{
							soundOpen.play(0);
							if(!OneYetOpened.getBoolean())
							{
//                                exButton.setIcon(new ImageIcon("pic/"+intTable.get(ij).toString()+".gif"));
								exButton.setIcon((ImageIcon)imageList.get(setInt));
//                                exButton.setText(intTable.get(ij).toString());
//                                exButton.setForeground(new Color(255, 0, 0));
								OneYetOpened.setBoolean(true);
								OneYetOpened.setLast(ij);
								exButton.incOCount();
							}
							else
							{
								exButton.incOCount();
//                                exButton.setIcon(null);
//                                exButton.setText(intTable.get(ij).toString());
//                                exButton.setIcon(new ImageIcon("pic/"+intTable.get(ij).toString()+".gif"));
								b1 = exButton;
								b2 = ((TRJButton)pushButton.get(OneYetOpened.getLast()));

								b1.setIcon((ImageIcon)imageList.get(setInt));
								if(!intTable.get(OneYetOpened.getLast()).equals(intTable.get(ij)))
								{
									canDoAction = false;
									timerWorking = true;
									timeToClose.start();
									OneYetOpened.setLast(-1);
									Scores -= MinC * (b1.getOCount() + b2.getOCount() - 2) / 2;
									lblScores.setText(Integer.toString(Scores));
								}
								else
								{
//                                    exButton.setForeground(new Color(255, 0, 0));
									soundTwins.play(0);
									b1.setCanPressState(false);
									b2.setCanPressState(false);
									Opened += 1;
									if(b1.getOCount() == 2) b1.decOCount();
									if(b2.getOCount() == 2) b2.decOCount();
									Scores += 2 * MaxC / (b1.getOCount() + b2.getOCount());
									lblScores.setText(Integer.toString(Scores));

									if(Opened == Bwidth * Bheight / 2)
									{
										processEndGame();
									}
								}
								OneYetOpened.setBoolean(false);
							}
						}
					}
				}
			});
			pushButton.add(exButton);
		}

		// Setting contentPanel configuration
		JPanel copyRight = new JPanel();
		copyRight.setBorder(BorderFactory.createLoweredBevelBorder());

		JPanel contentPane = new JPanel();
		contentPane.setLayout(new GridBagLayout());
		contentPane.setBorder(BorderFactory.createEtchedBorder());
		// Adding buttons
		lblScores.setText("0");
		lblScores.setBorder(BorderFactory.createCompoundBorder(
		        BorderFactory.createEtchedBorder(), BorderFactory.createRaisedBevelBorder()
		));
		lblScores.setFocusable(false);
		lblScores.addActionListener(newGame);
		contentPane.add(lblScores, new GridBagConstraints(0, 1, Bwidth, 1, 1.0, 1.0,
		                                                  GridBagConstraints.CENTER, GridBagConstraints.BOTH,
		                                                  new Insets(2, 0, 2, 0), 0, 0));
		txtPlayerName.setEditable(true);
		txtPlayerName.setText(lastPlayer);
		txtPlayerName.addKeyListener(txtKeyListener);
//		addActionListener(txtListener);
		contentPane.add(txtPlayerName,
		                new GridBagConstraints(1, 0, Bwidth - 1, 1, 1.0, 1.0,
		                                       GridBagConstraints.CENTER,
		                                       GridBagConstraints.BOTH,
		                                       new Insets(0, 0, 0, 0), 0, 0));
		for(j = 0; j < Bheight; j++)
			for(i = 0; i < Bwidth; i++)
			{
				contentPane.add((JButton)pushButton.get(j * Bwidth + i),
				                new GridBagConstraints(i, j + 2, 1, 1, 1.0, 1.0,
				                                       GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				                                       new Insets(0, 0, 0, 0), 0, 0));
			}
		JLabel lblhttpbazon = new JLabel("<html><p align=\"CENTER\">" +
		                                 "<a href=\"http://bazon.n-chelny.ru\">" +
		                                 "&#169;&nbsp; BAZON Group 2004</a></p></html>");

		Map fontAttributes = new HashMap();
		fontAttributes.put(TextAttribute.SIZE, new Float(10.0));
		lblhttpbazon.setFont(new Font(fontAttributes));

		copyRight.add(lblhttpbazon, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
		                                                   GridBagConstraints.CENTER, GridBagConstraints.BOTH,
		                                                   new Insets(0, 0, 0, 0), 0, 0));

		contentPane.add(copyRight, new GridBagConstraints(0, Bheight + 2, Bwidth, 1, 1.0, 1.0,
		                                                  GridBagConstraints.CENTER, GridBagConstraints.BOTH,
		                                                  new Insets(0, 0, 0, 0), 0, 0));

		// End adding to contentpanel
		try //selecting locale and set names
		{
			ResourceBundle messages;
//			Locale configFromLocale;
//			String language = new String("");
//			String country = new String("");
//			StringTokenizer locTokenizer =
//			        new StringTokenizer
//			                ((String)configReader.configEntity.get("locale"), "_");
//
//			if(locTokenizer.hasMoreTokens())
//				language = locTokenizer.nextToken();
//			if(locTokenizer.hasMoreTokens())
//				country = locTokenizer.nextToken();
//			configFromLocale =
//			        new Locale(language, country);
			String property_name = (String)configReader.configEntity.get("locale");

			if(property_name.equalsIgnoreCase("Default BAZON"))
			{
				messages = ResourceBundle.getBundle(properties +
				                                    "/MessagesBundle", new Locale("", ""));
			}
			else
			{
				messages = ResourceBundle.getBundle(properties +
				                                    "/MessagesBundle_" + property_name);
			}
			setIntMessages(messages, (String)configReader.configEntity.get("locale"));
		}
		catch(MissingResourceException e)
		{
		}

		contentPane.add(txtsNameLabel,
		                new GridBagConstraints(0, 0, 2, 1, 1.0, 1.0,
		                                       GridBagConstraints.CENTER,
		                                       GridBagConstraints.BOTH,
		                                       new Insets(0, 2, 0, 1), 0, 0));

		setContentPane(contentPane);
		if(getExtendedState() == NORMAL)
		{
			pack();
			if(!NewGameStart)
			{
				setVisible(false);
				Dimension frameD = new Dimension(getSize());
				Dimension screenD = new Dimension(Toolkit.getDefaultToolkit().getScreenSize());
				setLocation((int)(screenD.getWidth() - frameD.getWidth()) / 2,
				            (int)(screenD.getHeight() - frameD.getHeight()) * 2 / 5);
				setVisible(true);
			}
			NewGameStart = false;
		}
		validate();
	}

	private void processExit()
	{
		configReader.writeConfig();
		System.exit(0);
	}

	private void processEndGame()
	{
		soundEnd.play(0);
		lblScores.setForeground(new Color(0, 255, 255));
		lblScores.setBackground(new Color(255, 0, 0));
		if(!lastPlayer.equals(""))
		{
			boolean hasBeatLevelRecord = false;

			if(configReader.getCurrentTableValues().size() != 0)
			{
				HashMap hmOfMax =
				        (HashMap)Collections.min( //    max
				                configReader.getCurrentTableValues(), scores_entry_comparator);

				String hi_scoreS = (String)hmOfMax.get("hi_score");

				try
				{
					int hi_score = Integer.parseInt(hi_scoreS);
					if(Scores > hi_score)
					{
						hasBeatLevelRecord = true;
					}
				}
				catch(NumberFormatException e)
				{
					hasBeatLevelRecord = true;
				}
			}
			else
			{
				hasBeatLevelRecord = true;
			}

			// zapis v tablicu recordov
			// wirte in any case
			String playerName = lastPlayer;
			String playerScore = Integer.toString(Scores);

			HashMap curplayer = configReader.findEqual(playerName);
			if(curplayer != null)
			{
				String lastScoreS = (String)curplayer.get("last_score");
				String gamesS = (String)curplayer.get("games");
				int lastScore = 0;
				int games = 1;

				try
				{
					lastScore = Integer.parseInt(lastScoreS.trim());
				}
				catch(NumberFormatException e)
				{
					e.printStackTrace();
				}
				try
				{
					games = Integer.parseInt(gamesS.trim());
				}
				catch(NumberFormatException e)

				{
					e.printStackTrace();
				}

				String hi_score = (String)curplayer.get("hi_score");
				try
				{
					int i_hi_score = Integer.parseInt(hi_score.trim());
					if(Scores > i_hi_score)
					{
						hi_score = Integer.toString(Scores);
					}
				}
				catch(NumberFormatException e)
				{
					e.printStackTrace();
				}

				String last_score = Integer.toString(
				        (lastScore * games + Scores) /
				        (games + 1));
				String p_games = Integer.toString((games + 1));

				String hash = configReader.genHash(playerName +
				                                   hi_score +
				                                   last_score +
				                                   p_games);

				if(hash != null)
				{
					curplayer.put("name", playerName);
					curplayer.put("hi_score", hi_score);
					curplayer.put("last_score", last_score);
					curplayer.put("games", p_games);

					Element curEL = (Element)curplayer.get("xml_entry");

					curEL.setAttribute("name", playerName);
					curEL.setAttribute("hi_score", hi_score);
					curEL.setAttribute("last_score", last_score);
					curEL.setAttribute("games", p_games);
					curEL.setAttribute("hash", hash);
				}
			}
			else
			{
				configReader.insertNewEntry(playerName,
				                            playerScore,
				                            playerScore,
				                            "1");
			}

			if(hasBeatLevelRecord)
			{
				// dialog box about max
				final JDialog jdMax = new JDialog(this, congratulations, true);
				JButton bOK = new JButton("OK");

				bOK.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						jdMax.dispose();
					}
				});

				JPanel dcontentPane = new JPanel();
				dcontentPane.setBorder(BorderFactory.createEtchedBorder());
				dcontentPane.setLayout(new GridBagLayout());
				dcontentPane.add(new JLabel(beatRecord),
				                 new GridBagConstraints(1, 1, 1, 1, 1.0, 1.0,
				                 GridBagConstraints.CENTER,
				                 GridBagConstraints.NONE,
				                 new Insets(5, 5, 5, 5), 0, 0));
				dcontentPane.add(bOK,
				                 new GridBagConstraints(1, 2, 1, 1, 1.0, 1.0,
				                 GridBagConstraints.CENTER,
				                 GridBagConstraints.NONE,
				                 new Insets(5, 0, 5, 0), 0, 0));
				jdMax.setContentPane(dcontentPane);
				jdMax.pack();

				Dimension frameD = new Dimension(jdMax.getSize());
				Dimension screenD = new Dimension(Toolkit.getDefaultToolkit().getScreenSize());
				jdMax.setLocation((int)(screenD.getWidth() - frameD.getWidth()) / 2,
				                  (int)(screenD.getHeight() - frameD.getHeight()) * 2 / 5);

				jdMax.setVisible(true);
			}
		}
	}

	private ActionListener recTable = new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			// tablicu recordov
			String level = configReader.getLevel();
			if(level.equalsIgnoreCase("easy"))
			{
				level = meniEasy.getText();
			}
			else if(level.equalsIgnoreCase("normal"))
			{
				level = meniNormal.getText();
			}
			else if(level.equalsIgnoreCase("hard"))
			{
				level = meniHard.getText();
			}

			ArrayList valuesFC = configReader.getCurrentTableValues();

			Collections.sort(valuesFC, scores_entry_comparator);

			Object[][] values = new Object[valuesFC.size()][4];
			for(int i = 0; i < valuesFC.size(); i++)
			{
				HashMap curEntry = (HashMap)valuesFC.get(i);

				String name = (String)curEntry.get("name");
				String hi_score = (String)curEntry.get("hi_score");
				String last_score = (String)curEntry.get("last_score");
				String games = (String)curEntry.get("games");

				values[i][0] = name;
				values[i][1] = hi_score;
				values[i][2] = last_score;
				values[i][3] = games;
			}

			boolean colorifix = configReader.getColorifix();

			RecTable frameRecTable = new RecTable(frameMain, level, values, configReader, colorifix);

			frameRecTable.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
			frameRecTable.pack();
			frameRecTable.setLocationRelativeTo(frameMain);
			frameRecTable.setVisible(true);
		}
	};

	Comparator scores_entry_comparator =
	        new Comparator()
	        {
		        public int compare(Object obj1, Object obj2)
		        {
			        int retval = 0;

			        retval = compareStringedInt(obj1, obj2, "hi_score");

			        if(retval == 0)
			        {
				        retval = compareStringedInt(obj1, obj2, "last_score");
			        }

			        if(retval == 0)
			        {
				        retval = compareStringedInt(obj1, obj2, "games");
			        }

			        if(retval == 0)
			        {
				        String o1hs = (String)((HashMap)obj1).get("name");
				        String o2hs = (String)((HashMap)obj2).get("name");

				        retval = o2hs.compareTo(o1hs);
			        }

			        return retval;
		        }

		        private int compareStringedInt(Object obj1, Object obj2, String attName)
		        {
			        int retval = 0;

			        String o1hs = (String)((HashMap)obj1).get(attName);
			        String o2hs = (String)((HashMap)obj2).get(attName);

			        try
			        {
				        int o1hsi = Integer.parseInt(o1hs);
				        int o2hsi = Integer.parseInt(o2hs);
				        Integer o1hsI = new Integer(o1hsi);
				        Integer o2hsI = new Integer(o2hsi);

				        retval = o2hsI.compareTo(o1hsI);
			        }
			        catch(NumberFormatException e)
			        {
				        retval = o2hs.compareTo(o1hs);
			        }

			        return retval;
		        }
	        };

	private Timer timeToClose = new Timer(1000, waitAndClose);

	private ActionListener show_rules =
	        new ActionListener()
	        {
		        public void actionPerformed(ActionEvent e)
		        {
                    JMGRules rules = new JMGRules(frameMain, meniRules.getText());

			        rules.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
			        rules.pack();
			        rules.setLocationRelativeTo(frameMain);
			        rules.setVisible(true);
		        }
	        };

	private ActionListener show_about =
	        new ActionListener()
	        {
		        public void actionPerformed(ActionEvent e)
		        {
			        JMGAbout about = new JMGAbout(frameMain);

			        about.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
			        about.pack();
			        about.setLocationRelativeTo(frameMain);
			        about.setVisible(true);
		        }
	        };

	private KeyListener txtKeyListener =
	        new KeyListener()
	        {
		        public void keyPressed(KeyEvent e)
		        {
		        }

		        public void keyTyped(KeyEvent e)
		        {
		        }

		        public void keyReleased(KeyEvent e)
		        {
			        lastPlayer = txtPlayerName.getText();
		        }
	        };

	public static void main(String[] args) throws Exception
	{
		boolean locked = false;
		File fileforlock = new File("MemoryGame.run");
		FileLock flck = new FileOutputStream(fileforlock).getChannel().tryLock();

        if(flck == null) // previous instance runned
        {
	        locked = true;

	        final JFrame jframeOneInstance = new JFrame();
	        jframeOneInstance.setTitle("SoS");

	        JButton bOK = new JButton("OK");

	        bOK.addActionListener(new ActionListener()
	        {
		        public void actionPerformed(ActionEvent e)
		        {
			        jframeOneInstance.dispose();
		        }
	        });

	        JPanel contentPane = new JPanel();
	        contentPane.setBorder(BorderFactory.createEtchedBorder());
	        contentPane.setLayout(new GridBagLayout());
	        contentPane.add(new JLabel("Only one instance can be run"),
	                         new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
	                         GridBagConstraints.CENTER,
	                         GridBagConstraints.NONE,
	                         new Insets(5, 5, 5, 5), 0, 0));
	        contentPane.add(bOK,
	                         new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0,
	                         GridBagConstraints.CENTER,
	                         GridBagConstraints.NONE,
	                         new Insets(5, 0, 5, 0), 0, 0));
	        jframeOneInstance.setContentPane(contentPane);
	        jframeOneInstance.pack();

	        Dimension frameD = new Dimension(jframeOneInstance.getSize());
	        Dimension screenD = new Dimension(Toolkit.getDefaultToolkit().getScreenSize());
	        jframeOneInstance.setLocation((int)(screenD.getWidth() - frameD.getWidth()) / 2,
	                          (int)(screenD.getHeight() - frameD.getHeight()) * 2 / 5);

	        jframeOneInstance.setVisible(true);
        }

		if(!locked)
		{
			fileforlock.deleteOnExit();

			if(configReader.getErrorCode() == ConfigurationReaderWriter.SUCCESS)
			{
				configReader.readConfig();

				MemoryMain frameMain = new MemoryMain();
				frameMain.pack();
				Dimension frameD = new Dimension(frameMain.getSize());
				Dimension screenD = new Dimension(Toolkit.getDefaultToolkit().getScreenSize());
				frameMain.setLocation((int)(screenD.getWidth() - frameD.getWidth()) / 2,
				                      (int)(screenD.getHeight() - frameD.getHeight()) * 2 / 5);
				frameMain.setVisible(true);
			}
		}
	}
}
