/**
 * Created by IntelliJ IDEA.
 * User: turtle
 * Date: Jan 7, 2004
 * Time: 1:45:37 PM
 * To change this template use Options | File Templates.
 */
package ru.nchelny.bazon.MemoryGame.main;

import ru.nchelny.bazon.MemoryGame.swingutils.MGColor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.ArrayList;

public class RecTable extends JDialog
{
	public static String tabREC = "Scores list of level";
    public static String playerName = "Player name";
    public static String playerHiScore = "HiScore";
    public static String playerLastScore = "Last Score";
	public static String playerGames = "Games played";
	public static String dynamicColors = "Dynamic colors";

	private Timer colorTimer = null;

	private ArrayList coloredElements = new ArrayList();

	private JLabel infoLabel = new JLabel();
	private int cGB = 0;
	private int iiGB = 2;
	private int idGB = 3;
	private int iGB = iiGB;

	private ConfigurationReaderWriter config = null;

	private int colorModule = 2; //Module -1

    public RecTable(Frame owner, String level, Object[][] values, ConfigurationReaderWriter config, boolean colorifix)
    {
	    super(owner, true);
	    setTitle(tabREC + " '" +level + "'");

	    this.config = config;

	    infoLabel.setText("<html>" +
	                      "<body>" +
	                      "<p align=\"center\">" +
	                      tabREC +
	                      "</p>" +
	                      "<p align=\"center\">" +
	                      " '" + level + "'" +
	                      "</p>" +
	                      "</body>" +
	                      "</html>");

	    JPanel infoPanel = new JPanel(new GridBagLayout());
	    infoPanel.add(infoLabel,
	                  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
	                                         GridBagConstraints.CENTER,
	                                         GridBagConstraints.NONE,
	                                         new Insets(0, 0, 0, 0), 0, 0));

	    JPanel tabnew = new JPanel(new GridBagLayout());

	    generateTable(tabnew, values);

        JScrollPane tabrecPane = new JScrollPane(tabnew);
	    tabrecPane.setPreferredSize(new Dimension(200, 300));

	    JCheckBox checkColor = new JCheckBox(dynamicColors, colorifix);
	    checkColor.addActionListener(checkListener);

        JPanel contentPane = new JPanel();
        contentPane.setLayout(new GridBagLayout());
	    contentPane.setPreferredSize(new Dimension(200, 300));

	    contentPane.add(infoPanel,
	                    new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0,
	                                           GridBagConstraints.CENTER,
	                                           GridBagConstraints.HORIZONTAL,
	                                           new Insets(0, 0, 0, 0), 0, 0));
        contentPane.add(tabrecPane,
                        new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0,
                                               GridBagConstraints.CENTER,
                                               GridBagConstraints.BOTH,
                                               new Insets(0, 0, 0, 0), 0, 0));

	    contentPane.add(checkColor,
	                    new GridBagConstraints(0, 2, 1, 1, 1.0, 0.0,
	                                           GridBagConstraints.WEST,
	                                           GridBagConstraints.NONE,
	                                           new Insets(0, 0, 0, 0), 0, 0));

	    setContentPane(contentPane);

	    colorTimer = new Timer(10, timerListener);
	    if(colorifix)
	    {
		    colorTimer.start();
	    }
    }

	private void generateTable(JPanel container, Object[][] values)
	{
		container.removeAll();

		JPanel recordsPanel = new JPanel(new GridBagLayout());

        for(int i = 0; i < values.length; i++)
        {
	        JLabel name = new JLabel((String)values[i][0]);
	        JLabel score = new JLabel((String)values[i][1]);
	        JPanel scorePanel = new JPanel(new GridBagLayout());

	        name.setForeground(new MGColor(0, 0, 0));
	        score.setForeground(new MGColor(0, 0, 0));

	        coloredElements.add(name);
	        coloredElements.add(score);

	        scorePanel.setToolTipText(playerLastScore + " " + values[i][2] + ";" +
	                                  playerGames + " " + values[i][3]);

	        scorePanel.add(name,
                           new GridBagConstraints(0, 0, 1, 1, 0.7, 0.0,
                                                  GridBagConstraints.WEST,
                                                  GridBagConstraints.NONE,
                                                  new Insets(0, 5, 0, 0), 0, 0));
	        scorePanel.add(score,
                           new GridBagConstraints(1, 0, 1, 1, 0.3, 0.0,
                                                  GridBagConstraints.CENTER,
                                                  GridBagConstraints.NONE,
                                                  new Insets(0, 0, 0, 0), 0, 0));
	        recordsPanel.add(scorePanel,
	                         new GridBagConstraints(0, i * 2, 1, 1, 1.0, 0.0,
	                                                GridBagConstraints.NORTH,
	                                                GridBagConstraints.HORIZONTAL,
	                                                new Insets(2, 0, 2, 0), 0, 0));
	        recordsPanel.add(new JSeparator(),
	                         new GridBagConstraints(0, i * 2 + 1, 2, 1, 1.0, 0.0,
	                                                GridBagConstraints.CENTER,
	                                                GridBagConstraints.HORIZONTAL,
	                                                new Insets(0, 0, 0, 0), 0, 0));
        }

		container.add(recordsPanel,
		              new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
		                                     GridBagConstraints.NORTH,
		                                     GridBagConstraints.HORIZONTAL,
		                                     new Insets(0, 0, 0, 0), 0, 0));
	}

	private MGColor getColor(MGColor oldColor)
	{
		int cR = oldColor.getRed();
		int cG = oldColor.getGreen();
		int cB = oldColor.getBlue();
		int iR = oldColor.getiR();
		int iG = oldColor.getiG();
		int iB = oldColor.getiB();

		cR += iR;
		if(cR > 255 || cR < 0)
		{
			cR -= iR;
			iR = -(iR / Math.abs(iR)) * (int)Math.round(colorModule * Math.random() + 1);
		}

		cG += iG;
		if(cG > 255 || cG < 0)
		{
			cG -= iG;
			iG = -(iG / Math.abs(iG)) * (int)Math.round(colorModule * Math.random() + 1);
		}

		cB += iB;
		if(cB > 255 || cB < 0)
		{
			cB -= iB;
			iB = -(iB / Math.abs(iB)) * (int)Math.round(colorModule * Math.random() + 1);
		}

		MGColor retval = new MGColor(cR, cG, cB);
		retval.setiRGB(iR, iG, iB);

		return retval;
	}

	private Color getLabelColor()
	{
		Color retval = new Color(0, cGB, cGB);

		cGB+=iGB;
		if(cGB > 255)
		{
			cGB -= iGB;
			iGB = -idGB;
		}
		else if(cGB < 0)
		{
			cGB -= iGB;
			iGB = iiGB;
		}

		return retval;
	}

	private ActionListener timerListener = new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			infoLabel.setForeground(getLabelColor());

            for(int i = 0; i < coloredElements.size(); i+=2)
            {
	            JLabel element1 = (JLabel)coloredElements.get(i);
	            JLabel element2 = (JLabel)coloredElements.get(i+1);

	            MGColor setColor = getColor((MGColor)element1.getForeground());
	            element1.setForeground(setColor);
	            element2.setForeground(setColor);
            }
		}
	};

	private ActionListener checkListener = new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			JCheckBox source = (JCheckBox)e.getSource();
			boolean checked = source.isSelected();

			if(checked)
			{
				colorTimer.start();
				config.setColorifix("yes");
			}
			else
			{
				colorTimer.stop();
				config.setColorifix("no");
			}
		}
	};
}
