/*
 *	ClipPlayer.java
 *
 *	This file is part of the Java Sound Examples.
 */

/*
 *  Copyright (c) 1999 - 2001 by Matthias Pfisterer <Matthias.Pfisterer@web.de>
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as published
 *   by the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
package ru.nchelny.bazon.MemoryGame.notBAZON;

import	java.io.*;
import java.net.URL;
import	javax.sound.sampled.*;

public class ClipPlayer
{
    private Clip m_clip;

    /**
     * Original ClipPalyer.java is part of the Java Sound Examples.
     * Developed for MemoryGame by Turtle//BAZON Group (http://bazon.n-chelny.ru)
     * @see <a href=http://bazon.n-chelny.ru>http://bazon.n-chelny.ru<>
     */
	public ClipPlayer(URL clipFile)
	{
        AudioInputStream audioInputStream = null;
        try
        {
            audioInputStream = AudioSystem.getAudioInputStream(clipFile);
        }
        catch (Exception e)
        {
        }
        if (audioInputStream != null)
        {
            AudioFormat format = audioInputStream.getFormat();
            DataLine.Info info = new DataLine.Info(Clip.class, format);
            try
            {
                m_clip = (Clip) AudioSystem.getLine(info);
                m_clip.addLineListener(cplistener);
                m_clip.open(audioInputStream);
            }
            catch (LineUnavailableException e)
            {
            }
            catch (IOException e)
            {
            }
        }
	}

    public void play(int nLoopCount)
    {
        try
        {
            m_clip.loop(nLoopCount);
        }
        catch(NullPointerException e)
        {
        }
    }

    private LineListener cplistener = new LineListener()
    {
        public void update(LineEvent event)
        {
            if (event.getType().equals(LineEvent.Type.STOP))
            {
                m_clip.stop();
            }
            else if (event.getType().equals(LineEvent.Type.CLOSE))
            {
                m_clip.close();
            }
        }
    };
}
