/**
 * Created by IntelliJ IDEA.
 * User: turtle
 * Date: Mar 1, 2004
 * Time: 9:27:20 PM
 * To change this template use Options | File Templates.
 */
package ru.nchelny.bazon.MemoryGame.utils;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.StringTokenizer;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

public class ClassPathParser
{
	private String pathseparator = ":";
	private String fileseparator = "/";
	private String themes;
	private String properties;
	private ArrayList cpath = new ArrayList();

	public ClassPathParser(String themes, String properties)
	{
		this.themes = themes;
		this.properties = properties;

		pathseparator = System.getProperty("path.separator");
		fileseparator = System.getProperty("file.separator");

		StringTokenizer stok = new StringTokenizer(
		        System.getProperty("java.class.path"),
		        pathseparator,
		        false);

		while(stok.hasMoreTokens())
		{
			String path = stok.nextToken();

			File pfile = new File(path);

			if(pfile.isDirectory())
			{
                String[] files = pfile.list();

				for(int i = 0; i < files.length; i++)
				{
					String curEntry = files[i];

					if(curEntry.equalsIgnoreCase(themes) ||
					        curEntry.equalsIgnoreCase(properties))
					{
						boolean endop = false;
						ArrayList pathlist = new ArrayList();
						ArrayList pfileslist = new ArrayList();

						pfileslist.add(pfile);

						while(!endop)
						{
							endop = true;
							ArrayList newpfiles = new ArrayList();

							for(int iii = 0; iii < pfileslist.size(); iii ++)
							{
								File localpfile = (File)pfileslist.get(iii);

								if(localpfile.isDirectory())
								{
									File[] listdir = localpfile.listFiles();

									for(int ii = 0; ii < listdir.length; ii++)
									{
										endop = false;
										File current = listdir[ii];
										String curPath = current.getPath();

										curPath = curPath.substring(path.length() + 1);
										if(current.isDirectory())
										{
											curPath += "/";
										}

										while(curPath.indexOf(fileseparator) != -1)
										{
											int fsepcharpos = curPath.indexOf(fileseparator);

											curPath = curPath.substring(0, fsepcharpos) +
											          "{t.fsep}" +
											          curPath.substring(fsepcharpos + 1);
										}
										while(curPath.indexOf("{t.fsep}") != -1)
										{
											int fsepcharpos = curPath.indexOf("{t.fsep}");

											curPath = curPath.substring(0, fsepcharpos) +
											          "/" +
											          curPath.substring(fsepcharpos + "{t.fsep}".length());
										}

										newpfiles.add(current);
										pathlist.add(curPath);
									}
								}
							}
							pfileslist = newpfiles;
						}
						cpath.addAll(pathlist);
					}
				}
			}
			else if(pfile.isFile())
			{
				try
				{
					JarFile jarfile = new JarFile(path, true);

					JarEntry jarentrythemes = jarfile.getJarEntry(themes);
					JarEntry jarentryproperties = jarfile.getJarEntry(properties);

					if(jarentrythemes != null || jarentryproperties != null)
					{
						Enumeration en = jarfile.entries();

						while(en.hasMoreElements())
						{
							String curElement = ((JarEntry)en.nextElement()).getName();

							if(curElement.indexOf(themes) == 0 ||
							        curElement.indexOf(properties) == 0)
							{
								cpath.add(curElement);
							}
						}
					}
				}
				catch(IOException e)
				{
					e.printStackTrace();
				}
			}
		}
		Collections.sort(cpath);
//		System.out.println("");
	}

	private ArrayList getNKEndsWith(String begins, String pattern)
	{
		ArrayList retval = new ArrayList();

		for(int i = 0; i < cpath.size(); i++)
		{
			String current = (String)cpath.get(i);
			StringTokenizer st = new StringTokenizer(current, "/");

			if(current.endsWith(pattern) &&
			   current.startsWith(begins) &&
			   st.countTokens() == 2)
			{
				retval.add(current);
			}
		}

		return retval;
	}

	public ArrayList getPropListOfEndsWith(String pattern)
	{
		ArrayList retval = getNKEndsWith(properties + "/MessagesBundle", pattern);

		return retval;
	}

	public ArrayList getThemeList()
	{
		ArrayList retval = new ArrayList();
		ArrayList preretval = getNKEndsWith(themes, "/");

		for(int i = 0; i < preretval.size(); i++)
		{
			String record = (String)preretval.get(i);
			StringTokenizer st = new StringTokenizer(record, "/");

			st.nextToken();
			retval.add(st.nextToken());
		}

		return retval;
	}

	public boolean exist(String pathname)
	{
		return cpath.contains(pathname);
	}
}
